#include "pitches.h"

//momentarty switch pin
const int buttonPin = 12;
int buttonState = 0; 
//Mapped sensor value
int backPos;
//Value for the "normal position"
int basePos = 40;
//vibration motor digital pin
int vibePin = 9;
//buzzer digital pin
int buzzerPin = 13;
//length of delay between alarms 
long intervalAlarm = 400;
// will store last time buzzer was updated
long previousMillisAlarm = 0;

int value, value2 ;
long time=0;
int periode = 100;
int displace = 500;

void setup() {
  Serial.begin(9600);
  //Initialize the appropriate pins to outputs or inputs 
  pinMode(vibePin, OUTPUT);
  pinMode(buzzerPin, OUTPUT);
  pinMode(buttonPin, INPUT);     

}

void loop() {

  //Start reading the y axis values coming from the accelerometer. 
  int yAxis = analogRead(A0);
  // map the values to a range that is easyer to work with (1-100).
  backPos = map(yAxis, 240,400,0,100);

  //start reading the button state
  buttonState = digitalRead(buttonPin);

  //if the button is pressed set the value of base position to the current back position 
  // this sets a "normal" state that the code will then measure a difference from. 
  if (buttonState == HIGH) {     
    basePos = backPos; 
  } 

  //if backPos is in a bad postion
  if(backPos > basePos + 5){
    //turn on the vibration motor 
    vibeMotor();
    //turn on the piezo buzzer 
    alarm();
  }
  //otherwise turn off the motor and buzzer
  else{
    digitalWrite(vibePin, LOW);
    digitalWrite(buzzerPin, LOW);
  }
}

//fuction that controls the piezo buzzer
void alarm(){
  //use blink with out delay logic and tone library to pulse the alarm. 
  unsigned long currentMillisAlarm = millis();
  if(currentMillisAlarm - previousMillisAlarm > intervalAlarm) {
    //reset the "timer"
    previousMillisAlarm = currentMillisAlarm;
    //turn on buzzer
    tone(buzzerPin, 65,200);
  }
}

//fuction that controls the vibration motor 
void vibeMotor(){
  //fade without delay logic pulses the vibration motor. 
  time = millis();
  value = 128+127*cos(2*PI/periode*time);
  value2 = 128+127*cos(2*PI/periode*(displace-time));
  analogWrite(vibePin, value);

}





















